//+------------------------------------------------------------------+
//|                                             Test_DemaOnArray.mq5 |
//|                                                          Integer |
//|                          https://login.mql5.com/ru/users/Integer |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "https://login.mql5.com/ru/users/Integer"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_plots   1
//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

input int            DemaPeriod  =  14;
input ENUM_MA_METHOD DemaMethod  =  MODE_EMA;

//--- indicator buffers
double         DBuffer[];
double         M1Buffer[];
double         M2Buffer[];
double         data[];
#include <IncOnArray/IncDemaOnArray.mqh>
CDemaOnArray dema;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   dema.Init(DemaPeriod,DemaMethod);

//--- indicator buffers mapping
   SetIndexBuffer(0,DBuffer,INDICATOR_DATA);

   SetIndexBuffer(1,M1Buffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(2,M2Buffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(3,data,INDICATOR_CALCULATIONS);

   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,dema.BarsRequired());
   PlotIndexSetString(0,PLOT_LABEL,dema.Name());

//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
   int start;
   if(prev_calculated>0)
     {
      start=prev_calculated-1;
     }
   else
     {
      start=0;
     }
   for(int i=start;i<rates_total;i++)
     {
      data[i]=price[i];
     }

   dema.Solve(rates_total,prev_calculated,data,M1Buffer,M2Buffer,DBuffer);

   return(rates_total);
  }
//+------------------------------------------------------------------+
